/*
 *  MyDebugDraw.cpp
 *  iphoneOpenGLBox2D
 *
 *  Created by Campbell Chris on 7/30/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */

#import <OpenGLES/ES1/gl.h>
#include "MyDebugDraw.h"

void MyDebugDraw::DrawSolidPolygon(const b2Vec2* vertices, int32 vertexCount, const b2Color& color) 
{
    //set up vertex array
    GLfloat glverts[16]; //allow for polygons up to 8 vertices
    glVertexPointer(2, GL_FLOAT, 0, glverts); //tell OpenGL where to find vertices
    glEnableClientState(GL_VERTEX_ARRAY); //use vertices in subsequent calls to glDrawArrays
    
    //fill in vertex positions as directed by Box2D
    for (int i = 0; i < vertexCount; i++) {
		glverts[i*2]   = vertices[i].x;
		glverts[i*2+1] = vertices[i].y;
    }
	
	glEnable(GL_BLEND);
	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    
    //draw solid area
    glColor4f( color.r, color.g, color.b, 0.5f );
    glDrawArrays(GL_TRIANGLE_FAN, 0, vertexCount);
	
    //draw lines
	glColor4f( color.r, color.g, color.b, 1 );
    glDrawArrays(GL_LINE_LOOP, 0, vertexCount);
}